#coding: Windows-1251
from os import *
from shutil import *
import filecmp
from time import *

def compileERT(sourceFolder, ertName):
    system('gcomp.exe -c -DD "' + sourceFolder + '" -F "' + ertName+'"')
    atime=0
    mtime=0
    for fname in listdir(sourceFolder):
        subFileName=sourceFolder+"\\"+fname
        if path.isdir(subFileName): continue
        atime=max(atime, path.getatime(subFileName))
        mtime=max(mtime, path.getmtime(subFileName))
    utime(ertName, (atime, mtime))

def decompileERT(ertName, sourceFolder):
#    print "ertName "+ertName
#    print "sourceFolder "+sourceFolder
#    print 'gcomp.exe -d -v -F "'+ertName + '" -DD "' + sourceFolder + '" --truncate-mms'

#    system('gcomp.exe -d -v -F "'+ertName + '" -DD "' + sourceFolder + '" --truncate-mms')
    system('gcomp.exe -d -v -F "'+ertName + '" -DD "' + sourceFolder + '" --no-empty-mxl')
    atime=path.getatime(ertName)
    mtime=path.getmtime(ertName)
    for fname in listdir(sourceFolder):
        subFileName=sourceFolder+'\\'+fname
        if path.isdir(subFileName): continue
        if path.getmtime(subFileName)>mtime:
            utime(subFileName, (atime, mtime))

def copySingle(srcName, dstName):
    if path.exists(dstName):
        if filecmp.cmp(srcName, dstName, 0): return
    copy2(srcName, dstName)

def createFolder(folderName):
    if not path.exists(folderName):
        mkdir(folderName)
    if path.isfile(folderName):
        remove(folderName)
        mkdir(folderName)

def compileFolder(srcFolder, dstFolder):
    createFolder(dstFolder)
    for fname in listdir(srcFolder):
        if fname == 'CVS': continue
        if fname == '.svn': continue
	if fname == 'Scripts': continue
        compileItem(srcFolder+'\\'+fname, dstFolder+'\\'+fname)

def compileItem(srcName, dstName):
    if path.isfile(srcName):
        copySingle(srcName, dstName)
        return
    if path.exists(srcName+'\\.1s'):
        if path.exists(srcName+'\\.frm'):
            compileERT(srcName, dstName+'.ert')
            return
    compileFolder(srcName, dstName)

def decompileFolder(srcFolder, dstFolder):
    createFolder(dstFolder)
    for fname in listdir(srcFolder):
        decompileItem(srcFolder+'\\'+fname, dstFolder+'\\'+fname)

def decompileItem(srcName, dstName):
#    print "srcName "+srcName
#    print "dstName "+dstName

    if path.isdir(srcName):
        decompileFolder(srcName, dstName)
    elif path.splitext(srcName)[1].upper() == ".ERT":
        decompileERT(srcName, path.splitext(dstName)[0])
    else:
        copySingle(srcName, dstName)
